#!/bin/sh
######################################################################
# PyukiWiki Installer CGI version 0.3
# $Id$
# PyukiWiki __PYUKIWIKIVERSION____BUILD__ (__CODE__)
######################################################################
export PATH="/bin:/usr/bin:/usr/local/bin:/opt/bin:/usr/opt/bin:/usr/opt/sbin:/bin:/usr/sbin:/usr/local/sbin:/usr/games:/usr/games/bin:$PATH"
export PYU=PyukiWiki
export IVER=0.4
export SH=sh
export TAC=tar
export TAO=xvf
export ACD=__ARCCMD__
export AET=__ARCEXT__
export TCD=__TXTCMD__
export TET=__TXTEXT__
export VER="__PYUKIWIKIVERSION__"
export BUILD="__BUILD__"
export CODE="__CODE__"
export X="installer_sub.sh"
export S=".itb"
export I=".iitb"
export TMPPL="./.tmp.$REMOTE_ADDR"
export QS=$QUERY_STRING
export LN=$HTTP_ACCEPT_LANGUAGE
export IJA=インストー
export IUJ=$IJAル
export IAJ=$IJAラ
export IUE=Install
export IAE=Installer

hh() {
	cat <<EOF
Content-type: text/html;charset=utf-8

EOF
}

err() {
	if [ $CGI = 1 ]; then
		if [ "`echo $LN | grep ja`" != "" ]; then
			hh
			cat <<EOF
<html><head><title>$PYU$IAJ</title></head><body><h2>$PYU$IAJ エラー</h2><hr>$PYU CGI$IAJは以下の理由で正常に起動できませんでした。<br>手動で$IUJして下さい。<hr>
$1
EOF
		else
			hh
			cat <<EOF
<html><head><title>$PYU $IAE</title></head><body><h2>$PYU $IAE</h2><hr>Can't execute $PYU CGI $IAE<br>Prease manual $IUE<hr>
$1
EOF
		fi
		echo \<\/body\><\/html\>
	else
		echo Can\'t execute $PYU $IAE
		echo Prease manual $IUE
	fi
	exit
}

wrc() {
	test_file="./writetestfile_$PYU"
	echo test>$test_file
	if [ -f $test_file ]; then
		rm -rf $test_file
		return 0;
	fi
	rm -rf $test_file
	if [ "`echo $LN | grep ja`" != "" ]; then
		err "CGIがユーザー権限で実行されていないので、$IUJできません"
	else
		err "It is not running on the user rights CGI, you can not $IUE"
	fi
	return 1;
}

cmdc() {
	if [ "$1" = "" ]; then
		return 0;
	fi
	CMD=`which $1`
	if [ "$CMD" != "" ]; then
		return 0;
	else
		if [ "`echo $LN | grep ja`" != "" ]; then
			err "コマンド $1 がありません"
		else
			err "Not found command $1"
		fi
	fi
}

chk() {
	cmdc $SH
	cmdc echo
	cmdc chmod
	cmdc sed
	cmdc cp
	cmdc rm
	cmdc mv
	cmdc cat
	cmdc grep
	cmdc $TAC
	cmdc $ACD
	cmdc $TCD
	wrc
}

export PWD=`pwd`

if [ "$REMOTE_ADDR" != "" ]; then
	CGI=1
else
	CGI=0
fi

if [ $CGI = 1 ]; then
	hh
	chk
	SE=cgistart
	if [ "`echo $QS|grep license`" != "" ]; then
		SE=license
	fi
	if [ "`echo $QS|grep step1`" != "" ]; then
		SE=gpl
	fi
	if [ "`echo $QS|grep step2`" != "" ]; then
		SE=art
	fi
	if [ "`echo $QS|grep step3`" != "" ]; then
		SE=cgititle
	fi
	if [ "`echo $QS|grep $IUE`" != "" ]; then
		SE=cgiinstall
	fi
else
	chk
	SE=shell
fi
