FILES=\
	./temp/license_art_en.htm 	./temp/license_art_ja.htm 	./temp/license_gpl_en.htm 	./temp/license_gpl_ja.htm 	./temp/installer.sh 	./temp/installer2.sh 	./temp/installer_sub.sh

all:${FILES}

./temp/license_art_en.htm: ./build/license_art_en.html
	perl build/compressfile.pl html ./temp/license_art_en.1 build/license_art_en.html
	perl build/build.pl cp "./temp" "0644" "./temp/license_art_en.1" "./temp/license_art_en.htm" "release" "lf" "euc" "" >/dev/null
	rm -f ./temp/license_art_en.1

./temp/license_art_ja.htm: ./build/license_art_ja.html
	perl build/compressfile.pl html ./temp/license_art_ja.1 build/license_art_ja.html
	perl build/build.pl cp "./temp" "0644" "./temp/license_art_ja.1" "./temp/license_art_ja.htm" "release" "lf" "euc" "" >/dev/null
	rm -f ./temp/license_art_ja.1

./temp/license_gpl_en.htm: ./build/license_gpl_en.html
	perl build/compressfile.pl html ./temp/license_gpl_en.1 build/license_gpl_en.html
	perl build/build.pl cp "./temp" "0644" "./temp/license_gpl_en.1" "./temp/license_gpl_en.htm" "release" "lf" "euc" "" >/dev/null
	rm -f ./temp/license_gpl_en.1

./temp/license_gpl_ja.htm: ./build/license_gpl_ja.html
	perl build/compressfile.pl html ./temp/license_gpl_ja.1 build/license_gpl_ja.html
	perl build/build.pl cp "./temp" "0644" "./temp/license_gpl_ja.1" "./temp/license_gpl_ja.htm" "release" "lf" "euc" "" >/dev/null
	rm -f ./temp/license_gpl_ja.1

./temp/installer.sh: ./build/installer.sh
	perl build/build.pl cp "./temp" "0644" "build/installer.sh" "./temp/installer.sh" "release" "lf" "euc" "" >/dev/null

./temp/installer2.sh: ./build/installer2.sh
	perl build/build.pl cp "./temp" "0644" "build/installer2.sh" "./temp/installer2.sh" "release" "lf" "euc" "" >/dev/null

./temp/installer_sub.sh: ./build/installer_sub.sh
	perl build/build.pl cp "./temp" "0644" "build/installer_sub.sh" "./temp/installer_sub.sh" "release" "lf" "euc" "" >/dev/null
