######################################################################
# list.inc.pl - This is PyukiWiki, yet another Wiki clone.
# $Id$
#
# "PyukiWiki" ver 0.2.1-alpha2-dev5 $$
# Author: Nekyo 
# Copyright (C) 2004-2007 Nekyo
# Copyright (C) 2005-2012 PyukiWiki Developers Team
# http://pyukiwiki.info/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sfjp.jp/
# License: GPL3 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return:CRLF Code=UTF-8 1TAB=4Spaces
######################################################################
# v0.2.1 maxpage
# v0.2 non_list
# v0.1
######################################################################
$list::maxlist=100
	if(!defined($list::maxlist));
$list::pgcounts=5
	if(!defined($list::pgcounts));
sub plugin_list_action {
	my $navi = qq(\n<div id="body"><div id="top" style="text-align:center">);
	my @body;
	my $prev = '';
	my $char = '';
	my $idx = 1;
	my $cnt = 0;
	my $pg=1;
	my $displaypage=$::form{page}+0;
	$displaypage=1 if($displaypage < 1);
	foreach my $page (sort keys %::database) {
		next if ($page =~ $::non_list);
		next unless(&is_readable($page));
		$cnt++;
		if($cnt > $list::maxlist) {
			$cnt=0;
			$pg++;
		}
		$char = substr($page, 0, 1);
		if (!($char =~ /[a-zA-Z0-9]/)) {
			$char = $::resource{list_plugin_otherchara};
		}
		if ($prev ne $char) {
			if ($prev ne '') {
				$navi .= " |\n";
				$body[$pg] .= "  </ul>\n </li>\n</ul>\n";
			}
			$prev = $char;
			$navi .= qq(<a id="top_$idx" href="?cmd=list&amp;page=$cnt#head_$idx"><strong>$prev</strong></a>);
		}
		if ($prev ne $char || $body[$pg] eq "") {
			$body[$pg] .= <<"EOD";
<ul>
 <li><a id="head_$idx" href="?cmd=list&amp;page=$cnt#top_$idx"><strong>$prev</strong></a>
  <ul>
EOD
			$idx++;
		}
		$body[$pg] .= qq(<li><a href="@{[&make_cookedurl(&encode($page))]}">@{[&escape($page)]}</a>@{[&escape(&get_subjectline($page))]}</li>\n);
	}
	$navi.=qq(</div>);
	my $lastpage;
	for(my $i=1; $body[$i] ne ""; $i++) {
		$body[$i] .= qq(</ul></li></ul></li></ul></div>);
		$lastpage=$i;
	}
	my $pgcounts=$list::pgcounts;
	my $pagenavi;
	if($lastpage > 1 || 1) {
		my $minpage=$displaypage - $pgcounts < 1 ? 1 : $displaypage - $pgcounts;
		my $prevpage=$displaypage - 1 < 1 ? 1 : $displaypage - 1;
		my $maxpage=$minpage eq 1 ? $pgcounts * 2 : $lastpage < $displaypage + $pgcounts - 1 ? $lastpage : $displaypage + $pgcounts;
		my $nextpage=$lastpage < $displaypage + 1 ? $lastpage : $displaypage + 1;
		$maxpage=$maxpage > $lastpage ? $lastpage : $maxpage;
		$minpage=$maxpage eq $lastpage ? ($maxpage - $pgcounts * 2 < 1 ? 1 : $maxpage - $pgcounts * 2) : $minpage;
		$pagenavi=qq([<a id="pg_first" href="?cmd=list&amp;page=1">$::resource{list_firstpage}</a>]);
		$pagenavi.=qq([<a id="pg_prev" href="?cmd=list&amp;page=$prevpage">$::resource{list_prevpage}</a>]);
		for(my $i=$minpage; $i<=$maxpage; $i++) {
			if($displaypage eq $i) {
				$pagenavi.=qq([<strong id="pg_$i">$i</strong>]&nbsp;);
			} else {
				$pagenavi.=qq([<a id="pg_$i" href="?cmd=list&amp;page=$i">$i</a>]&nbsp;);
			}
		}
		$pagenavi.=qq([<a id="pg_next" href="?cmd=list&amp;page=$nextpage">$::resource{list_nextpage}</a>]);
		$pagenavi.=qq([<a id="pg_last" href="?cmd=list&amp;page=$lastpage">$::resource{list_lastpage}</a>]);
		$pagenavi=qq(<div align="center">$pagenavi</div>);
		$body[$displaypage]=$pagenavi . "<hr />" . $body[$displaypage] . "<hr />" . $pagenavi;
	}
	return ('msg' => "\t$::resource{list_plugin_title}", 'body' => $navi . $body[$displaypage]);
}
1;
__END__
